
#ifndef DOUBLEVEC_H
#define DOUBLEVEC_H


/** \file

   <b>Copyright and Use</b>

   You may use this source code without limitation and without
   fee as long as you include:

<pre>
     This software was written and is copyrighted by Ian Kaplan, Bear
     Products International, www.bearcave.com, 2001, 2002, 2003
</pre>

   This software is provided "as is", without any warrenty or
   claim as to its usefulness.  Anyone who uses this source code
   uses it at their own risk.  Nor is any support provided by
   Ian Kaplan and Bear Products International.

   Please send any bug fixes or suggested source changes to:
<pre>
     iank@bearcave.com
</pre>

 */


#include "RCArray.h"

typedef RCArray<double> DoubleArray;

/**
   A growable reference counted array of doubles which 
   implements copy-on-write semantics (see RCArray).
 */
class DoubleVec : public DoubleArray
{
private:
  void init(double intialVal );

public:
  DoubleVec() : DoubleArray() {}
  DoubleVec(size_t initialSize) : DoubleArray( initialSize ) {}
  DoubleVec(size_t initialSize, double initVal ) : 
    DoubleArray(initialSize, initVal) {}

  size_t length() { return DoubleArray::length(); }
  size_t getRefCnt() { return DoubleArray::getRefCnt(); }
};


#endif
